//============================================================================
// FILE: C_CoreEntitySpec.h
//
// TYPE: C++CLASS 
// DESCRIPTION: entête des spécifications d'entités "moteur" de CONTROL DIESE
// 
// AUTHORS: Rellier (INRA/UBIA, Toulouse)
// REFERENCE : "Fondements ontologiques des systèmes pilotés"
//             R. Martin-Clouaire, J.-P. Rellier (INRA/UBIA, Toulouse)
//=X===============X=============================X============================

#ifndef _C_COREENTITYSPEC_HH
#define _C_COREENTITYSPEC_HH

// SYSTEM INCLUDES
//
//#include <>                                    //

// PROJECT INCLUDES
//
#include "EntitySpec.h" 

class ContinuousProcess;
class DiscreteProcess;

/**@name Classes prédéfinies de spécifications d'ensembles d'entités

\begin{itemize} \item Directive d'inclusion : {\tt \#include C\_CoreEntitySpec.h} \end{itemize}

Les classes présentées dans ce chapitre sont des sous-classes de {\bf EntitySpec}. C'est normalement l'utilisateur qui crée des descendants de cette classe de base, en fonction de son domaine d'application. Cependant, certains spécifications font partie de la spécification des systèmes de décision et opérant. Les classes correspondantes sont donc prédéfinies dans \CD. Il s'agit :
\begin{itemize}
\item des spécifications d'opération, descripteur des spécifications d'objets opérés, elles-mêmes composants des activités primitives,
\item ...
\end{itemize}  
*/ 
//@{

// X///////////////X/////////////////////////////X////////////////////////////
 
/**@name Spécification d'ensemble d'entités pour la classe {\bf Operation}
\index{OperationEntitySpec}Une telle spécification permet d'instancier, quand on lui applique la méthode {\bf Expand}, une opération de la classe dont le symbole sera déterminé par un appel à {\bf ReferenceClassId}.
*/
/*
//@{
         /// 
class OperationEntitySpec : public EntitySpec
{
public:
          // Constructeur de base. 
   OperationEntitySpec();       
 };
//@} 
*/

// X///////////////X/////////////////////////////X////////////////////////////

//@} // fin toutes classes prédéfinies d'ES

#endif  // _C_CORENTITYSPEC_HH
