//============================================================================
// FILE: C_OperationResourceSpecification.h
//
// TYPE: C++CLASS
// DESCRIPTION: entête des spécifications de ressources propres d'd'opération (dans une activité)
// 
// AUTHORS: Rellier (INRA/UBIA, Toulouse)
// REFERENCE : "Fondements ontologiques des systèmes pilotés"
//             R. Martin-Clouaire, J.-P. Rellier (INRA/UBIA, Toulouse)
//=X===============X=============================X============================

#ifndef _C_OPERATIONRESOURCESPECIFICATION_HH
#define _C_OPERATIONRESOURCESPECIFICATION_HH

// SYSTEM INCLUDES
//

// PROJECT INCLUDES
//
#include "Entity.h"

#include "C_CoreTypes.h"
#include "C_SingleResource.h"

// EXTERNAL REFERENCES

/**@name Spécification des ressources propres à une opération
\begin{itemize} \item Directive d'inclusion : {\tt \#include C\_OperationResourceSpecification.h} \end{itemize}
*/ 
//@{
        ///
class OperationResourceSpecification : public Entity
{
 public:
          // Constructeur de base.
   OperationResourceSpecification();

           /// Etablit et renvoie une liste (au sens d'une disjonction) de listes de ressources propres d'opération. Le descripteur DEVELOPPED\_LIST n'est pas valué. L'allocation pour l'opérateur de l'activité doit avoir été générée et passée en paramètre. Le second argument est l'opération qui possède la présente spécification de ressources.\index{méthodes!Develop}  
pEntityDTab* ReturnDevelopment(pEntityTab* perfAlloc, Operation*);
           // 
  pEntityDTab* MakeDisjunctionByANYONE(pEntityTab*, int);

           // 
  pEntityDTab* MakeDisjunctionByMAX(pEntityTab*);
  
           // 
  pEntityDTab* MakeDisjunctionByALL(pEntityTab*);

           // 
  pEntityDTab* MakeDisjunctionByDISJ(pEntityTab*, int);
  
           // 
  pEntityDTab* MakeDisjunctionBySETS(pEntityTab*, int);

           // Une fois établie la valeur du descripteur de symbole SPECIFIED_OPERATION, génère une disjonction de listes de ressources propres d'opération, sous la forme d'une liste d'AllocatedOperationResourceSet. Cette liste devient la valeur du descripteur DEVELOPPED\_LIST. L'allocation pour l'opérateur de l'activité doit avoir été générée et passée en paramètre.\index{méthodes!Develop}  
//   void     Develop(pEntityTab* perfAlloc);


 private:
 };


//@}  // fin OperationResourceSpecification

#endif  // _C_OPERATIONRESOURCESPECIFICATION_HH
