#!/bin/csh
# !!! instantiate <engine> with [bdiese cdiese odiese] then remove this line !!!
setenv ENGINE <engine>
# !!! instantiate <major> and <minor> numbers of the current DIESE release
#     then remove this comment !!!
setenv MAJOR <major>
setenv MINOR <minor>
# !!! instantiate <appli> then remove this line before saving !!!
setenv APPLI_NAME <appli>

# check the local shell
#----------------------
setenv myshell sh
echo $SHELL | grep csh > tmpInstallAPPLI
if(-s tmpInstallAPPLI) then
  setenv myshell csh
endif
rm -f tmpInstallAPPLI
if($myshell == sh) then
  echo "||| "
  echo "||| Please run 'install_APPLI_lib.sh' instead."
  echo "||| "
  exit
endif

setenv DIESE_HD "$DIESE_TOOLS"
setenv KBS_HD "$DIESE_KBS"
setenv SOURCE $PWD

# message on hold
#----------------
echo "||| "
echo "||| Installation of $APPLI_NAME""_D$MAJOR.$MINOR is in progress ..."
echo "||| "

# copy cygwin1.dll if present
#----------------------------
cd "$DIESE_HD"
if(-e "$SOURCE"/cygwin1.dll) then
  /bin/cp -i "$SOURCE"/cygwin1.dll .
endif

# move lib APPLI to its final destination
#----------------------------------------
cd "$KBS_HD"
mkdir -p libKBS
cd libKBS
setenv SRC_LIB "$SOURCE"/lib
/bin/cp -i "$SRC_LIB"/* .

#create the final release destination
#------------------------------------
cd "$KBS_HD"
mkdir -p KBS
cd KBS
mkdir -p "$ENGINE"
cd "$ENGINE"
setenv DEST "$APPLI_NAME"_D"$MAJOR.$MINOR"
mkdir -p "$DEST"

# move READ_ME
#-------------
cd "$DEST"
/bin/cp "$SOURCE"/READ_ME .

# move executables to its final destination
#--------------------------------------------
mkdir -p exec
cd exec
setenv SRC_EXE "$SOURCE"/exec
/bin/cp "$SRC_EXE"/main* .
cd ..

# move Liv appli to its final destination
#----------------------------------------
setenv SRC_LIV "$SOURCE"/Liv
rm -f -r Liv
/bin/cp -r "$SRC_LIV" .

# move in appli to its final destination
#----------------------------------------
setenv SRC_IN "$SOURCE"/in
if (-e "$SRC_IN") then
  rm -f -r in
  /bin/cp -r "$SRC_IN" .
endif

# move out appli to its final destination
#----------------------------------------
setenv SRC_OUT "$SOURCE"/out
if (-e "$SRC_OUT") then
  rm -f -r out
  /bin/cp -r "$SRC_OUT" .
endif

# move doc appli to its final destination
#----------------------------------------
setenv SRC_DOC "$SOURCE"/doc
if (-e "$SRC_DOC") then
  rm -f -r doc
  /bin/cp -r "$SRC_DOC" .
endif

# back to release for cleaning
#-----------------------------
cd "$SOURCE"

# removing release archive
#-------------------------
echo "||| "
echo "||| Installation done ..."
echo "||| "
echo "||| "
echo "||| Do you want to delete the release directory content (Y/N)?"
echo "||| ($SOURCE)"
echo "||| (excepted the currently running install_APPLI_lib.csh command"
echo "||| and the READ_ME file to be deleted later)"
echo "||| "
setenv delsource $<
if(($delsource == Y) || ($delsource == y)) then
  if(-e "$SOURCE"/cygwin1.dll) then
    rm -f "$SOURCE"/cygwin1.dll
  endif
  rm -f "$SOURCE"/install_APPLI_lib.sh
  rm -f "$SOURCE"/makeRelease_APPLI*
  rm -f -r "$SOURCE"/exec
  rm -f -r "$SOURCE"/lib
  rm -f -r "$SOURCE"/Liv
  rm -f -r "$SOURCE"/in
  rm -f -r "$SOURCE"/out
  rm -f -r "$SOURCE"/doc
endif
echo "||| "
echo "||| Do you want to delete the release archive (Y/N)?"
echo "||| ($SOURCE.tar)"
echo "||| "
setenv delsource $<
if(($delsource == Y) || ($delsource == y)) then
 rm -f "$SOURCE".tar
endif

# up to final destination
#--------------------------
cd ..

echo "||| "
echo "||| Installation of $KBS_HD/$DEST done."
echo "||| Type any character to exit."
echo "||| "
setenv tmp $<
